#!/bin/sh -efu

. install2-init-functions

cat >"$destdir/tmp/instkernel" <<'EOF'
#!/bin/sh -efu

# For all given /dev/mapper/lvm2_<grp>_<vol> create
#    /dev/mapper/<grp>-<vol>      -> /dev/mapper/lvm2_<grp>_<vol>
#    /dev/mapper/lvm2|<grp>|<vol> -> /dev/mapper/lvm2_<grp>_<vol>
#
for dev in $(find /dev/mapper -name 'lvm*_*_*'); do
	ln -s $dev $(echo $dev | sed -e 's/\(lvm.*\)_\(.*\)_\(.*\)/\2-\3/')
	ln -s $dev $(echo $dev | sed -e 's/\(lvm.*\)_\(.*\)_\(.*\)/\1|\2|\3/')
done

MKINITRD_OPTIONS='--omit-ide-modules'
if [ -d /proc/scsi/usb-storage ]; then
	MKINITRD_OPTIONS="--with usb-storage --with ehci-hcd --with usbhid --with uhci-hcd --with ohci-hcd $MKINITRD_OPTIONS"
fi
export MKINITRD_OPTIONS

# %{version}-%{name}-%{release} is needed for /sbin/installkernel,
# which waiting something like 2.6.27-std-def-alt12

kern_list="$(rpmquery -a --qf='%{version}-%{name}-%{release}\n' 'kernel-image-*')"

# FIXME: apply reverse sort order in vain attempt to get "right" default kernel in bootloader menu.
printf '%s\n' "$kern_list" |
	sort -ru |
	sed -e 's#kernel-image-##' |
	DURING_INSTALL= LOADER=/bin/true xargs -rn1 /sbin/installkernel -n

rm -f /tmp/instkernel
EOF

chmod +x "$destdir/tmp/instkernel"
exec_chroot /tmp/instkernel
